/**************************************************************

   ██████╗ ██████╗ ██╗   ██╗██╗     ███████╗██╗   ██╗██████╗ 
  ██╔════╝██╔═══██╗██║   ██║██║     ██╔════╝██║   ██║██╔══██╗
  ██║     ██║   ██║██║   ██║██║     █████╗  ██║   ██║██████╔╝
  ██║     ██║   ██║██║   ██║██║     ██╔══╝  ██║   ██║██╔══██╗
  ╚██████╗╚██████╔╝╚██████╔╝███████╗███████╗╚██████╔╝██║  ██║
   ╚═════╝ ╚═════╝  ╚═════╝ ╚══════╝╚══════╝ ╚═════╝ ╚═╝  ╚═╝

   Dans cette page sont rangées toutes les fonctions relatives 
   au couleurs dans le programme. Les palettes de couleurs sont
   chargées depuis les assets du programme
   
***************************************************************/     



PImage[] palettes;
color[] colorPalette =  new color[5];



void colorInit(){
  
  /* cette fonction initialise toute les différentes pallettes de couleurs
  en chargeant les images contenues dans les assets du programme */
  
  int l = listFiles("data/palettes").length;
  palettes = new PImage[l];
  
  for(int i =0; i < l ; i++) palettes[i]=loadImage("palettes/palette_"+i+".png");
}



void setColor(int n){
  
  /* cette fonction enregistre les valeurs RVB de la palette séléctionnée dans
  les assets, pour pouvoir les utilisers dans les éléments UI par la suite. 
  Le numéro de pallette séléctionnée est également transmise au shaders. */
  
  PImage img = palettes[n];
  int l = 5 ;
  int x = img.width/l;
  int y = img.height/2;
  
  for(int i =0; i < l; i++) colorPalette[i] = img.get(x/2+x*i,y);
  shaderSetColor( n );
}
