#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D texture;
varying vec4 vertTexCoord;

void main(void) {
  
  vec4 color;

  // distance des pixels voisins
  vec2 texOffset2 = vec2(0.001,0.001);

  // attribution de toutes les coordonnées
  vec2 tc0 = vertTexCoord.st + vec2(          0.0, -texOffset2.t);
  vec2 tc1 = vertTexCoord.st + vec2(-texOffset2.s,           0.0);
  vec2 tc2 = vertTexCoord.st + vec2(          0.0,           0.0);
  vec2 tc3 = vertTexCoord.st + vec2(+texOffset2.s,           0.0);
  vec2 tc4 = vertTexCoord.st + vec2(          0.0, +texOffset2.t);
  
  // couleurs pas coorconées
  vec4 col0 = texture2D(texture, tc0);
  vec4 col1 = texture2D(texture, tc1);
  vec4 col2 = texture2D(texture, tc2);
  vec4 col3 = texture2D(texture, tc3);
  vec4 col4 = texture2D(texture, tc4);

  // moyenne des couleurs
  vec4 sum = (col0 + col1 + col2 + col3 + col4) / 5.0; 
  
  // compare les valeur :
  // si les pixels voisons sont différents les uns des autre dans un sens diagonal,
  // alors la valeur du pixel central remplacée par une valeur moyenne
  if (col0!=col4 && col1!=col3) color = sum;  
  else color = col2;

  // applique les modifications
  gl_FragColor = color;  
}
