#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D palette;
uniform vec2 texOffset;
uniform float divide;
uniform float amplitude;
uniform float inc;

varying vec4 vertColor;
varying vec4 vertTexCoord;


void main(void) {

  float ray = 0.5;
  float PI = 3.1415926535897932384626433832795;
  float mult = PI * 4.0 * (amplitude+1);
  int div = int( divide * 4.0 ) + 1;
  float amp = 2 * (amplitude+1);
  vec4 colorArray[5];

    colorArray[0] = texture2D(palette, vec2(0.1,0.5));
    colorArray[4] = texture2D(palette, vec2(0.3,0.5));
    colorArray[3] = texture2D(palette, vec2(0.5,0.5));
    colorArray[2] = texture2D(palette, vec2(0.7,0.5));
    colorArray[1] = texture2D(palette, vec2(0.9,0.5));
  
  vec2 tc4 = vertTexCoord.st;


  // calcule le radiant du pixel par rapport au centre de l'image
  float rx = ray - tc4.x;
  float ry = ray - tc4.y;
  float arx = abs(rx);
  float ary = abs(ry);
  float bx = round( ( rx + arx ) / 2.0 / rx );
  float by = round( ( ry + ary ) / 2.0 / ry );
  float bbx = abs( bx - by ); 
  float bby = abs( bbx - 1 );
  float a = arx * bby + ary * bbx;
  float b = ary * bby + arx * bbx;
  float add = abs( ( bx * 3.0 ) - by ) * ( PI / 2.0 );
  float offset = ( atan( a / b ) + add );

  int dist = int( sqrt( abs(tc4.x-ray) * abs(tc4.y-ray) + abs(tc4.y-ray) * abs(tc4.y-ray) ) * amp + inc*6);

  // applique une oscillation, et une rotation au radiant

  int c = int(mod(offset,PI) / PI * mult);

  float cc = mod(c,2);
  int d = 0;
  int dd = 1;
  if (div>1)d=1;
  if (div>1)dd=0;
  int nn = int( ( mod( c + dist, div+dd )+d ) * cc );

  gl_FragColor = colorArray[nn];

 
}
