#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D texture;
uniform sampler2D background;
uniform vec2 texOffset;

varying vec4 vertColor;
varying vec4 vertTexCoord;


void main(void) {
  
  vec2 tc4 = vertTexCoord.st;

  vec4 cam = texture2D(texture, tc4);

  vec2 ntc4 = vec2(tc4.s, tc4.t);

  // les pixels à comparer
  vec4 cap = texture2D(background, ntc4);

  // les mêmes convertis en HSB
  vec3 c = cam.rgb;
  vec3 t = cap.rgb;
  
  // compare les valeurs
  float r = abs(c.r-t.r);
  float v = abs(c.g-t.g);
  float b = abs(c.b-t.b);

  // compare les valeurs
  vec4 a  = vec4(cam.rgb,0.0);

  if      ( r > 0.08)  a.w = 1.0;
  else if ( v > 0.08)  a.w = 1.0;
  else if ( b > 0.08)  a.w = 1.0;
  
  gl_FragColor = a;

 
}
