#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D palette;
uniform sampler2D texture;
uniform sampler2D background;
uniform float amplitude;
//uniform float inc;
uniform float divide;

varying vec4 vertColor;
varying vec4 vertTexCoord;

void main(void) {

  // paramètres de l'effets
  int d = int( divide * 4.0 ) + 1;
  float ray = 0.5;
  float PI = 3.1415926535897932384626433832795;
  float mult = PI * 4.0 * (amplitude+1);

  float dist = 0.02 * (2-amplitude);
  float distt = dist/2.0;

  vec4 colorArray[5];

    colorArray[0] = texture2D(palette, vec2(0.1,0.5));
    colorArray[4] = texture2D(palette, vec2(0.3,0.5));
    colorArray[3] = texture2D(palette, vec2(0.5,0.5));
    colorArray[2] = texture2D(palette, vec2(0.7,0.5));
    colorArray[1] = texture2D(palette, vec2(0.9,0.5));

  vec2 tc[40];
    tc[0]   = vertTexCoord.st + vec2(sin(PI*0.0) * dist, cos(PI*0.0) * dist);
    tc[1]   = vertTexCoord.st + vec2(sin(PI*0.1) * dist, cos(PI*0.1) * dist);
    tc[2]   = vertTexCoord.st + vec2(sin(PI*0.2) * dist, cos(PI*0.2) * dist);
    tc[3]   = vertTexCoord.st + vec2(sin(PI*0.3) * dist, cos(PI*0.3) * dist);
    tc[4]   = vertTexCoord.st + vec2(sin(PI*0.4) * dist, cos(PI*0.4) * dist);
    tc[5]   = vertTexCoord.st + vec2(sin(PI*0.5) * dist, cos(PI*0.5) * dist);
    tc[6]   = vertTexCoord.st + vec2(sin(PI*0.6) * dist, cos(PI*0.6) * dist);
    tc[7]   = vertTexCoord.st + vec2(sin(PI*0.7) * dist, cos(PI*0.7) * dist);
    tc[8]   = vertTexCoord.st + vec2(sin(PI*0.8) * dist, cos(PI*0.8) * dist);
    tc[9]   = vertTexCoord.st + vec2(sin(PI*0.9) * dist, cos(PI*0.9) * dist);
    tc[10]  = vertTexCoord.st + vec2(sin(PI*1.0) * dist, cos(PI*1.0) * dist);
    tc[11]  = vertTexCoord.st + vec2(sin(PI*1.1) * dist, cos(PI*1.1) * dist);
    tc[12]  = vertTexCoord.st + vec2(sin(PI*1.2) * dist, cos(PI*1.2) * dist);
    tc[13]  = vertTexCoord.st + vec2(sin(PI*1.3) * dist, cos(PI*1.3) * dist);
    tc[14]  = vertTexCoord.st + vec2(sin(PI*1.4) * dist, cos(PI*1.4) * dist);
    tc[15]  = vertTexCoord.st + vec2(sin(PI*1.5) * dist, cos(PI*1.5) * dist);
    tc[16]  = vertTexCoord.st + vec2(sin(PI*1.6) * dist, cos(PI*1.6) * dist);
    tc[17]  = vertTexCoord.st + vec2(sin(PI*1.7) * dist, cos(PI*1.7) * dist);
    tc[18]  = vertTexCoord.st + vec2(sin(PI*1.8) * dist, cos(PI*1.8) * dist);
    tc[19]  = vertTexCoord.st + vec2(sin(PI*1.9) * dist, cos(PI*1.9) * dist);
    tc[20]  = vertTexCoord.st + vec2(sin(PI*0.05) * dist, cos(PI*0.05) * dist);
    tc[21]  = vertTexCoord.st + vec2(sin(PI*0.15) * dist, cos(PI*0.15) * dist);
    tc[22]  = vertTexCoord.st + vec2(sin(PI*0.25) * dist, cos(PI*0.25) * dist);
    tc[23]  = vertTexCoord.st + vec2(sin(PI*0.35) * dist, cos(PI*0.35) * dist);
    tc[24]  = vertTexCoord.st + vec2(sin(PI*0.45) * dist, cos(PI*0.45) * dist);
    tc[25]  = vertTexCoord.st + vec2(sin(PI*0.55) * dist, cos(PI*0.55) * dist);
    tc[26]  = vertTexCoord.st + vec2(sin(PI*0.65) * dist, cos(PI*0.65) * dist);
    tc[27]  = vertTexCoord.st + vec2(sin(PI*0.75) * dist, cos(PI*0.75) * dist);
    tc[28]  = vertTexCoord.st + vec2(sin(PI*0.85) * dist, cos(PI*0.85) * dist);
    tc[29]  = vertTexCoord.st + vec2(sin(PI*0.95) * dist, cos(PI*0.95) * dist);
    tc[30]  = vertTexCoord.st + vec2(sin(PI*1.05) * dist, cos(PI*1.05) * dist);
    tc[31]  = vertTexCoord.st + vec2(sin(PI*1.15) * dist, cos(PI*1.15) * dist);
    tc[32]  = vertTexCoord.st + vec2(sin(PI*1.25) * dist, cos(PI*1.25) * dist);
    tc[33]  = vertTexCoord.st + vec2(sin(PI*1.35) * dist, cos(PI*1.35) * dist);
    tc[34]  = vertTexCoord.st + vec2(sin(PI*1.45) * dist, cos(PI*1.45) * dist);
    tc[35]  = vertTexCoord.st + vec2(sin(PI*1.55) * dist, cos(PI*1.55) * dist);
    tc[36]  = vertTexCoord.st + vec2(sin(PI*1.65) * dist, cos(PI*1.65) * dist);
    tc[37]  = vertTexCoord.st + vec2(sin(PI*1.75) * dist, cos(PI*1.75) * dist);
    tc[38]  = vertTexCoord.st + vec2(sin(PI*1.85) * dist, cos(PI*1.85) * dist);
    tc[39]  = vertTexCoord.st + vec2(sin(PI*1.95) * dist, cos(PI*1.95) * dist);
  
  vec2 ttc[20];

    ttc[0]   = vertTexCoord.st + vec2(sin(PI*0.0) * distt, cos(PI*0.0) * distt);
    ttc[1]   = vertTexCoord.st + vec2(sin(PI*0.2) * distt, cos(PI*0.2) * distt);
    ttc[2]   = vertTexCoord.st + vec2(sin(PI*0.4) * distt, cos(PI*0.4) * distt);
    ttc[3]   = vertTexCoord.st + vec2(sin(PI*0.6) * distt, cos(PI*0.6) * distt);
    ttc[4]   = vertTexCoord.st + vec2(sin(PI*0.8) * distt, cos(PI*0.8) * distt);
    ttc[5]   = vertTexCoord.st + vec2(sin(PI*1.0) * distt, cos(PI*1.0) * distt);
    ttc[6]   = vertTexCoord.st + vec2(sin(PI*1.2) * distt, cos(PI*1.2) * distt);
    ttc[7]   = vertTexCoord.st + vec2(sin(PI*1.4) * distt, cos(PI*1.4) * distt);
    ttc[8]   = vertTexCoord.st + vec2(sin(PI*1.6) * distt, cos(PI*1.6) * distt);
    ttc[9]   = vertTexCoord.st + vec2(sin(PI*1.8) * distt, cos(PI*1.8) * distt);

  vec4 col[40];

    col[0]   = texture2D(background, tc[0]);
    col[1]   = texture2D(background, tc[1]);
    col[2]   = texture2D(background, tc[2]);
    col[3]   = texture2D(background, tc[3]);
    col[4]   = texture2D(background, tc[4]);
    col[5]   = texture2D(background, tc[5]);
    col[6]   = texture2D(background, tc[6]);
    col[7]   = texture2D(background, tc[7]);
    col[8]   = texture2D(background, tc[8]);
    col[9]   = texture2D(background, tc[9]);
    col[10]  = texture2D(background, tc[10]);
    col[11]  = texture2D(background, tc[11]);
    col[12]  = texture2D(background, tc[12]);
    col[13]  = texture2D(background, tc[13]);
    col[14]  = texture2D(background, tc[14]);
    col[15]  = texture2D(background, tc[15]);
    col[16]  = texture2D(background, tc[16]);
    col[17]  = texture2D(background, tc[17]);
    col[18]  = texture2D(background, tc[18]);
    col[19]  = texture2D(background, tc[19]);
    col[20]  = texture2D(background, tc[20]);
    col[21]  = texture2D(background, tc[21]);
    col[22]  = texture2D(background, tc[22]);
    col[23]  = texture2D(background, tc[23]);
    col[24]  = texture2D(background, tc[24]);
    col[25]  = texture2D(background, tc[25]);
    col[26]  = texture2D(background, tc[26]);
    col[27]  = texture2D(background, tc[27]);
    col[28]  = texture2D(background, tc[28]);
    col[29]  = texture2D(background, tc[29]);
    col[30]  = texture2D(background, tc[30]);
    col[31]  = texture2D(background, tc[31]);
    col[32]  = texture2D(background, tc[32]);
    col[33]  = texture2D(background, tc[33]);
    col[34]  = texture2D(background, tc[34]);
    col[35]  = texture2D(background, tc[35]);
    col[36]  = texture2D(background, tc[36]);
    col[37]  = texture2D(background, tc[37]);
    col[38]  = texture2D(background, tc[38]);
    col[39]  = texture2D(background, tc[39]);

  vec4 colt[10];

    colt[0]  = texture2D(background, ttc[0]);
    colt[1]  = texture2D(background, ttc[1]);
    colt[2]  = texture2D(background, ttc[2]);
    colt[3]  = texture2D(background, ttc[3]);
    colt[4]  = texture2D(background, ttc[4]);
    colt[5]  = texture2D(background, ttc[5]);
    colt[6]  = texture2D(background, ttc[6]);
    colt[7]  = texture2D(background, ttc[7]);
    colt[8]  = texture2D(background, ttc[8]);
    colt[9]  = texture2D(background, ttc[9]);
  
  float sum = (col[0].w + col[1].w  + col[2].w  + col[3].w  + col[4].w  + col[5].w  + col[6].w  + col[7].w  + col[8].w + col[9].w + 
              col[10].w + col[11].w  + col[12].w  + col[13].w  + col[14].w  + col[15].w  + col[16].w  + col[17].w  + col[18].w + col[19].w +
              col[20].w + col[21].w  + col[22].w  + col[23].w  + col[24].w  + col[25].w  + col[26].w  + col[27].w  + col[28].w + col[29].w + 
              col[30].w + col[31].w  + col[32].w  + col[33].w  + col[34].w  + col[35].w  + col[36].w  + col[37].w  + col[38].w + col[39].w )/40;  
  float sumt = (colt[0].w + colt[1].w  + colt[2].w  + colt[3].w  + colt[4].w  + colt[5].w  + colt[6].w  + colt[7].w  + colt[8].w + colt[9].w)/10; 

  

  // calcule le radiant du pixel par rapport au centre de l'image
  float rx = ray - vertTexCoord.x;
  float ry = ray - vertTexCoord.y;
  float arx = abs(rx);
  float ary = abs(ry);
  float bx = round( ( rx + arx ) / 2.0 / rx );
  float by = round( ( ry + ary ) / 2.0 / ry );
  float bbx = abs( bx - by ); 
  float bby = abs( bbx - 1 );
  float a = arx * bby + ary * bbx;
  float b = ary * bby + arx * bbx;
  float add = abs( ( bx * 3.0 ) - by ) * ( PI / 2.0 ); 
  float offset = ( atan( a / b ) + add );

  int c = int(mod(offset,PI) / PI * mult);

  float cc = mod(c,2);

  int nn = int( ( mod(c/2,d)+1 )*cc );

  

  /*float size = 0.02*(2-amplitude);

  float n = (vertTexCoord.x-vertTexCoord.y-inc*0.05) / size;
  int p = int(mod(n,2));
  int nn = int((mod(n/2,d)+1)*p);*/

  if (sum>0 && sumt==0) gl_FragColor = colorArray[nn];
  else gl_FragColor = colorArray[0];

 
}
