#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D palette;
uniform sampler2D background;
uniform float amplitude;
uniform float divide;

varying vec4 vertColor;
varying vec4 vertTexCoord;

void main(void) {

  // paramètres de l'effets
  int div = int( divide * 4.0 ) + 1;
  float amp = 0.1 * (amplitude*2-1);

  vec4 colorArray[5];

    colorArray[0] = texture2D(palette, vec2(0.1,0.5));
    colorArray[4] = texture2D(palette, vec2(0.3,0.5));
    colorArray[3] = texture2D(palette, vec2(0.5,0.5));
    colorArray[2] = texture2D(palette, vec2(0.7,0.5));
    colorArray[1] = texture2D(palette, vec2(0.9,0.5));

  // attribution de toutes les coordonnées
  vec2 tc[20];

    tc[0]  = vertTexCoord.st + vec2(-amp * 0.00, +amp * 0.00);
    tc[1]  = vertTexCoord.st + vec2(-amp * 0.05, +amp * 0.05);
    tc[2]  = vertTexCoord.st + vec2(-amp * 0.10, +amp * 0.10);
    tc[3]  = vertTexCoord.st + vec2(-amp * 0.15, +amp * 0.15);
    tc[4]  = vertTexCoord.st + vec2(-amp * 0.20, +amp * 0.20);
    tc[5]  = vertTexCoord.st + vec2(-amp * 0.25, +amp * 0.25);
    tc[6]  = vertTexCoord.st + vec2(-amp * 0.30, +amp * 0.30);
    tc[7]  = vertTexCoord.st + vec2(-amp * 0.35, +amp * 0.35);
    tc[8]  = vertTexCoord.st + vec2(-amp * 0.40, +amp * 0.40);
    tc[9]  = vertTexCoord.st + vec2(-amp * 0.45, +amp * 0.45);
    tc[10] = vertTexCoord.st + vec2(-amp * 0.50, +amp * 0.50);
    tc[11] = vertTexCoord.st + vec2(-amp * 0.55, +amp * 0.55);
    tc[12] = vertTexCoord.st + vec2(-amp * 0.60, +amp * 0.60);
    tc[13] = vertTexCoord.st + vec2(-amp * 0.65, +amp * 0.65);
    tc[14] = vertTexCoord.st + vec2(-amp * 0.70, +amp * 0.70);
    tc[15] = vertTexCoord.st + vec2(-amp * 0.75, +amp * 0.75);
    tc[16] = vertTexCoord.st + vec2(-amp * 0.80, +amp * 0.80);
    tc[17] = vertTexCoord.st + vec2(-amp * 0.85, +amp * 0.85);
    tc[18] = vertTexCoord.st + vec2(-amp * 0.90, +amp * 0.90);
    tc[19] = vertTexCoord.st + vec2(-amp * 0.95, +amp * 0.95);

  // récupération de toutes les valeurs
  vec4 col[20];

    col[0] = texture2D(background, tc[0]);
    col[1] = texture2D(background, tc[1]);
    col[2] = texture2D(background, tc[2]);
    col[3] = texture2D(background, tc[3]);
    col[4] = texture2D(background, tc[4]);
    col[5] = texture2D(background, tc[5]);
    col[6] = texture2D(background, tc[6]);
    col[7] = texture2D(background, tc[7]);
    col[8] = texture2D(background, tc[8]);
    col[9] = texture2D(background, tc[9]);
    col[10] = texture2D(background, tc[10]);
    col[11] = texture2D(background, tc[11]);
    col[12] = texture2D(background, tc[12]);
    col[13] = texture2D(background, tc[13]);
    col[14] = texture2D(background, tc[14]);
    col[15] = texture2D(background, tc[15]);
    col[16] = texture2D(background, tc[16]);
    col[17] = texture2D(background, tc[17]);
    col[18] = texture2D(background, tc[18]);
    col[19] = texture2D(background, tc[19]);

  // sommes de toutes les valeurs
  //float op = col[0].w + col[1].w  + col[2].w  + col[3].w  + col[4].w  + col[5].w  + col[6].w  + col[7].w  + col[8].w + col[9].w;  

  int s = int(20.0/float(div));
  vec4 color = colorArray[0];

  for (int i = 0 ; i <= div ; i ++ ) {
    float op = 0.0; 
    for (int j = 0 ; j <= s ; j ++ ) {
      int ind = (div-i) * s + j;
      if(tc[ind].x>0 && tc[ind].x<1 && tc[ind].y>0 && tc[ind].y<1){
        op += col[ind].w;
      }
    }
    if (op>0.0) color = colorArray[i];
  }
  gl_FragColor = color;   
}
